searchNodes=[{"doc":"Documentation for Promox .","ref":"Promox.html","title":"Promox","type":"module"},{"doc":"Enables mock :for the given protocol. Caveats Since defmock/1 is a macro, so remember to require Promox before calling Promox.defmock/1 . require Promox Promox . defmock ( for : MyProtocol )","ref":"Promox.html#defmock/1","title":"Promox.defmock/1","type":"macro"},{"doc":"Expects the protocol.name callback with arity given by code to be invoked with mock n times. Examples To expect MyProtocol.callback/1 to be called once: my_mock = Promox . new ( ) |&gt; Promox . expect ( MyProtocol , :callback , fn _mock -&gt; :ok end ) To expect MyProtocol.callback/1 to be called five times: my_mock = Promox . new ( ) |&gt; Promox . expect ( MyProtocol , :callback , 5 , fn _mock -&gt; :ok end )","ref":"Promox.html#expect/5","title":"Promox.expect/5","type":"function"},{"doc":"Initialize a new mock struct. my_mock = Promox . new ( ) # Promox.expect(my_mock, MyProtocol, :callback, fn _mock, ... -&gt; ... end) Since mocks are just isolated data structures, you can use them in concurrent processes. mock1 = Promox . new ( ) |&gt; Promox . expect ( MyProtocol , :callback , fn _mock , ... -&gt; :ok end ) mock2 = Promox . new ( ) |&gt; Promox . expect ( MyProtocol , :callback , fn _mock , ... -&gt; :error end ) assert :ok = MyProtocol . callback ( mock1 , ... ) assert :error = fn -&gt; MyProtocol . callback ( mock2 , ... ) end |&gt; Task . async ( ) |&gt; Task . await ( )","ref":"Promox.html#new/0","title":"Promox.new/0","type":"function"},{"doc":"Allows the protocol.name callback with arity given by code to be invoked with mock any times. The call would be delegated to code and returns whatever code returns. Caveat The first argument passed to code is always the mock being stubbed. stub/4 will overwrite any previous calls to stub/4 If expectations and stubs are defined for the same function and arity, the stub is invoked only after all expectations are fulfilled. Examples To allow MyProtocol.callback/1 to be called any times: my_mock = Promox . new ( ) |&gt; Promox . stub ( MyProtocol , :callback , fn _mock -&gt; :ok end )","ref":"Promox.html#stub/4","title":"Promox.stub/4","type":"function"},{"doc":"Verifys that all the expectations set for the mock have been called. Returns :ok if so; Otherwise, raises Promox.VerificationError .","ref":"Promox.html#verify!/1","title":"Promox.verify!/1","type":"function"},{"doc":"","ref":"Promox.State.html","title":"Promox.State","type":"module"},{"doc":"","ref":"Promox.State.html#expect/5","title":"Promox.State.expect/5","type":"function"},{"doc":"","ref":"Promox.State.html#get_expects/1","title":"Promox.State.get_expects/1","type":"function"},{"doc":"","ref":"Promox.State.html#new/0","title":"Promox.State.new/0","type":"function"},{"doc":"","ref":"Promox.State.html#retrieve/2","title":"Promox.State.retrieve/2","type":"function"},{"doc":"","ref":"Promox.State.html#stub/4","title":"Promox.State.stub/4","type":"function"},{"doc":"","ref":"Promox.UnexpectedCallError.html","title":"Promox.UnexpectedCallError","type":"exception"},{"doc":"","ref":"Promox.VerificationError.html","title":"Promox.VerificationError","type":"exception"},{"doc":"Promox Protocol-based mocks and explicit contracts in Elixir. See also Mox for Behaviour-based mocks.","ref":"readme.html","title":"Promox","type":"extras"},{"doc":"Add promox to your list of dependencies in mix.exs : def deps do [ { :promox , &quot;~&gt; 0.1.0&quot; , only : :test } ] end","ref":"readme.html#installation","title":"Promox - Installation","type":"extras"},{"doc":"Let's say we have a Storable protocol: defprotocol MyApp.Storable do @spec upload ( t ( ) , String . t ( ) , any ( ) ) :: :ok | { :error , any ( ) } def upload ( storage , path , data ) @spec download ( t ( ) , String . t ( ) ) :: { :ok , any ( ) } | { :error , any ( ) } def download ( storage , path ) end Then we define the mock for Storable in test_helper.exs : require Promox Promox . defmock ( for : MyApp.Storable ) (Notice that Promox.defmock is a macro, so we need to require Promox first.) Now in our tests, we can initialize mocks and define expectations on them: defmodule MyApp.Storable.WithRetryTest do use ExUnit.Case , async : true alias MyApp.Storable test &quot;retries upload `n` times&quot; do storable = Promox . new ( ) |&gt; Promox . expect ( Storable , :upload , 2 , fn _ , &quot;path&quot; , &quot;data&quot; -&gt; { :error , :test_retry } end ) |&gt; Promox . expect ( Storable , :upload , fn _ , &quot;path&quot; , &quot;data&quot; -&gt; :ok end ) storable_with_retry = Storable.WithRetry . new ( storable , max_attempt : 3 ) assert :ok = Storable . upload ( storable_with_retry , &quot;path&quot; , &quot;data&quot; ) Promox . verify! ( storable ) end end Multiple mocks Since a Promox mock is just a piece of data, you can initialize multiple mocks and define different expectations on them: defmodule MyApp.Storable.FallbackChainTest do use ExUnit.Case , async : true alias MyApp.Storable test &quot;falls=back to next storable when first storable fails&quot; do error_storable = Promox . new ( ) |&gt; Promox . stub ( Storable , :download , fn _ , &quot;path&quot; , &quot;data&quot; -&gt; { :error , :test_fallback } end ) ok_storable = Promox . new ( ) |&gt; Promox . stub ( Storable , :download , fn _ , &quot;path&quot; , &quot;data&quot; -&gt; { :ok , &quot;result from ok_storable&quot; } end ) fallback_chain = Storable.FallbackChain . new ( [ error_storable , ok_storable ] ) assert { :ok , &quot;result from ok_storable&quot; } = Storable . download ( fallback_chain , &quot;path&quot; ) end end Multi-process collaboration Again, since a Promox mock is just a piece of data, you can pass a mock to another process without managing allowances: defmodule MyApp.Storable.AsyncTest do use ExUnit.Case , async : true alias MyApp.Storable test &quot;falls=back to next storable when first storable fails&quot; do test = self ( ) mock_storable = Promox . new ( ) |&gt; Promox . expect ( Storable , :upload , fn _ , &quot;path&quot; , &quot;data&quot; -&gt; send ( test , :mock_gets_called ) :ok end ) async_storable = Storable.Async . new ( mock_storable ) assert :ok = Storable . upload ( async_storable , &quot;path&quot; , &quot;data&quot; ) assert_receive ( :mock_gets_called ) Promox . verify! ( mock_storable ) end end","ref":"readme.html#examples","title":"Promox - Examples","type":"extras"},{"doc":"Mox simplifies mocking Behaviour callbacks; Promox simplifies mocking Protocol callbacks. Protocols and Behaviours are both ways to achieve polymorphism in Elixir. You should pick Protocols or Behaviours depending on the problem in your hand. When you pick Protocols, you may need Promox to create mocks dynamically in your tests. Why would you choose Protocol/Promox over Behaviour/Mox?","ref":"readme.html#why-would-you-need-promox-when-mox-exists","title":"Promox - Why would you need Promox when Mox exists?","type":"extras"}]